'use strict'

/**
 * Represents a stack trace exception line item
 * @param method
 * @constructor
 */
function ExceptionFrame (method) {
  this.Method = method
}

/**
 * Represents an exception occuring in a transaction
 * @param err
 * @constructor
 */
function Exception (err) {
  this.Frames = []

  let self = this

  // setup frames
  if (err.stack) {
    let stackLines = err.stack.split('\n')
    if (stackLines) {
      stackLines.forEach(function (stackLine) {
        // filter out stackify-node-apm/lib lines
        if (stackLine &&
          !stackLine.includes('stackify-node-apm/lib') &&
          !stackLine.includes('stackify-node-apm/node_modules')) {
          self.Frames.push(new ExceptionFrame(stackLine.trim()))
        }
      })
    }
  }

  this.Exception = err.name
  this.Message = err.message ? err.message : err.name
  this.Timestamp = Date.now().toString()
}

module.exports = Exception
