'use strict'

/**
 * Timer with nanosecond precision
 * @constructor
 */
function Timer () {
  this._startMillis = Date.now()
  this._hrtime = process.hrtime()
}

/**
 * Get current time in milliseconds (with nanoseconds as a decimal)
 * @return double
 */
Timer.prototype.getCurrentTime = function getCurrentTime () {
  let currentHrTime = process.hrtime(this._hrtime)
  let secondsAsNanos = currentHrTime[0] * 1e9
  let nanos = currentHrTime[1]
  return this._startMillis + ((secondsAsNanos + nanos) / 1e6)
}

module.exports = Timer
